import { JsonPointer } from './createJsonPointer';
export declare const enum OperationType {
    Add = 0,
    Remove = 1,
    Replace = 2,
    Copy = 3,
    Move = 4,
    Test = 5,
}
export interface Operation {
    op: string;
    path: JsonPointer;
    toString(): string;
    apply(target: any): any;
}
export interface Add extends Operation {
    value: any;
}
export interface Remove extends Operation {
}
export interface Replace extends Operation {
    value: any;
    oldValue: any;
}
export interface Move extends Operation {
    from: JsonPointer;
}
export interface Copy extends Operation {
    from: JsonPointer;
}
export interface Test extends Operation {
    value: any;
}
declare function createOperation(type: OperationType, path: JsonPointer | string[], value?: any, from?: JsonPointer | string[], oldValue?: any): Operation;
export default createOperation;
